#ifndef _TEST_APP
#define _TEST_APP

#include "ofMain.h"

#include "ofxOpenCv.h"
#include "ofxOsc.h"
#include "ofxVectorMath.h"

#define _USE_LIVE_VIDEO		// uncomment this to use a live camera
// otherwise, we'll use a movie file

// not-local
#define HOST "128.208.1.60"
//#define HOST "bitlaunch.com"
#define PORT 48888
//#define PORT 80
#define PATH "/data/camera/glovePosition"

/*
#define HOST "localhost"
#define PORT 12345
#define PATH "/path"
*/


#define NUM_NOTES 19
#define NUM_INSTRUMENTS 5

class color
{
    public:

        float hue, sat;

        ofxVec2f pos;
};


class testApp : public ofBaseApp{
	
public:
	
	void setup();
	void update();
	void draw();
	
	void keyPressed  (int key);
	void mouseMoved(int x, int y );
	void mouseDragged(int x, int y, int button);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);
	void windowResized(int w, int h);
	
#ifdef _USE_LIVE_VIDEO
	ofVideoGrabber 		vidGrabber;
#else
	ofVideoPlayer 		vidPlayer;
#endif
	
	ofxCvColorImage		colorImg;
	ofxCvColorImage		origColorImg;
	
	ofxCvGrayscaleImage 	grayImage;
	ofxCvGrayscaleImage 	grayBg;
	ofxCvGrayscaleImage 	grayDiff;
	
	ofxCvContourFinder 	contourFinder;
	
	int 				threshold;
	bool				bLearnBakground;
	ofxCvBlob interestBlob;
	
	int camHeight, camWidth, margin;

    float lastSentXX;
    float lastSentYY;


    ofxCvColorImage		    colorImgHSV;    //the image doing the wrapping

    ofxCvGrayscaleImage		hueImg;     //Hue map
    ofxCvGrayscaleImage		satImg;     //Saturation map
    ofxCvGrayscaleImage             briImg;     //Brightness map

    ofxCvGrayscaleImage     reds;               //Grayscale image we are gonna run the contour finder over to find our color

    color                   one;                //color that we're gonna track

    unsigned char *         colorTrackedPixelsRed;      //just some raw images which we are gonna put pixels into
    ofTexture               trackedTextureRed;          //color texture that we are gonna draw to

    ofxCvContourFinder      finderRed;                  //contour finder, very handy 


	
	float oldXMin, oldXMax, oldX, oldY, xx, yy;
	int numNotes, numInstruments;
	
	bool showDebug, drawKeyboard;
	ofTexture colorImgTex;

private:
	ofxOscSender sender;
};

#endif
