
//
// JazzPianoVoice.ck
//
// This is an example of how to build a sample-driven sound patch for the
// new setup.
//
// Author: Andrew Smith <andrewrs@cs.washington.edu>
// Modified: 15 Mar 2011
//

public class JazzPianoVoice extends Voice {
    //// Constructor()
        ["Resources/Piano/060CHANGPIANOHARD_C4OGG.wav",
         "Resources/Piano/063CHANGPIANOHARD_D#4OGG.wav",
         "Resources/Piano/065CHANGPIANOHARD_F4OGG.wav",
         "Resources/Piano/066CHANGPIANOHARD_F#4OGG.wav",
         "Resources/Piano/067CHANGPIANOHARD_G4OGG.wav"
        ] @=> string samples[];
    
        SndBuf buffers[samples.size()];
        ADSR e[samples.size()];
    
        for (0 => int i; i < buffers.size(); i++) {
            samples[i] => buffers[i].read;
            e[i].set(10::ms, 200::ms, 1.0, 200::ms);
            e[i].keyOff();
            
            // Keep the buffer from playing initially
            buffers[i].samples() - 1 => buffers[i].pos;
            
            buffers[i] => e[i] => this;
        }
    //// End Constructor()
    
    
    
    // This handles events that come into this voice (fingers on/off)
    public void play() {
        while (true) {
            noteEvent => now;
            
            if (noteEvent.on) {
                0 => buffers[noteEvent.finger].pos;
                e[noteEvent.finger].keyOn();
            } else {
                e[noteEvent.finger].keyOff();
            }
        }
    }
}