
//
// SineVoice.ck
//
// This is an example of how to build a synthesis-driven sound patch for the
// new setup.
//
// Author: Andrew Smith <andrewrs@cs.washington.edu>
// Modified: 15 Mar 2011
//

public class SineVoice extends Voice {
	//// Constructor()
	    SinOsc s[5];
	    ADSR e[5];
	
        60 => int currentFreq;
        
        for (0 => int i; i < s.size(); i++) {
    	    currentFreq => s[i].freq;
    	    e[i].set(3::ms, 200::ms, 1.0, 50::ms);
            e[i].keyOff();
    	    
    	    s[i] => e[i] => this;
    	    
    	    2 *=> currentFreq;
	    }
	//// End Constructor()
	
	
	
	// This handles events that come into this voice (fingers on/off)
	public void play() {
	    while (true) {
	        noteEvent => now;

	        if (noteEvent.on) {
	            e[noteEvent.finger].keyOn();
	        } else {
	            e[noteEvent.finger].keyOff();
	        }
	    }
	}
}