
// Voice.ck
//
// Voice acts as the base class for any 'instrument' voice,
// whether it's built on samples or generators or anything
// in between
//
// Author(s): Zack Brown <zacharyb@cs.washington.edu>,
//            Andrew Smith <andrewrs@cs.washington.edu>
// Modified: 15 Mar 2011
//

public class Voice extends UGen {
    
    // Pressure for each finger
    float glovePressure[5];
    
    // Note (on/off) event
    NoteEvent noteEvent;
    
    
    
    //
    // Handle messages from OSC
    //
    
    // Update the current glove touch pressure
    public void updatePressure(int finger, float p) {
        p => glovePressure[finger];
    }
    
    
    
    //
    // Abstract methods
    //
    
    // This gets overridden by each specific instrument
    public void play() {}
}