
//
// WeirdFMVoice.ck
//
// This is an example of how to build a sample-driven sound patch for the
// new setup.
//
// Author: Andrew Smith <andrewrs@cs.washington.edu>
// Modified: 15 Mar 2011
//

public class WeirdFMVoice extends Voice {
    //// Constructor()
        "Resources/Downloads/JokerFM2.wav" @=> string sound;
    
        SndBuf buffers[5];
        ADSR e[5];
    
        0.25 => float currentRate;
    
        for (0 => int i; i < buffers.size(); i++) {
            sound => buffers[i].read;
            e[i].set(10::ms, 200::ms, 1.0, 10::ms);
            e[i].keyOff();
            currentRate => buffers[i].rate;
            2 => buffers[i].interp;
            1 => buffers[i].loop;
            0 => buffers[i].pos;
            
            buffers[i] => e[i] => this;
            
            2 *=> currentRate;
        }
    //// End Constructor()
    
    
    
    // This handles events that come into this voice (fingers on/off)
    public void play() {
        while (true) {
            noteEvent => now;
            
            if (noteEvent.on) {
                e[noteEvent.finger].keyOn();
            } else {
                e[noteEvent.finger].keyOff();
            }
        }
    }
}