
//
// WowSynthVoice.ck
//
// This is an example of how to build a sample-driven sound patch for the
// new setup.
//
// Author: Andrew Smith <andrewrs@cs.washington.edu>
// Modified: 15 Mar 2011
//

public class WowSynthVoice extends Voice {
    //// Constructor()
        "Resources/Downloads/wha_wow.wav" @=> string sound;
    
        SndBuf buffers[5];
        ADSR e[5];
    
        0.5 => float currentRate;
    
        for (0 => int i; i < buffers.size(); i++) {
            sound => buffers[i].read;
            e[i].set(10::ms, 200::ms, 1.0, 200::ms);
            e[i].keyOff();
            currentRate => buffers[i].rate;
            
            // Keep the buffer from playing initially
            buffers[i].samples() - 1 => buffers[i].pos;
            
            buffers[i] => e[i] => this;
            
            2 *=> currentRate;
        }
    //// End Constructor()
    
    
    
    // This handles events that come into this voice (fingers on/off)
    public void play() {
        while (true) {
            noteEvent => now;
            
            if (noteEvent.on) {
                0 => buffers[noteEvent.finger].pos;
                e[noteEvent.finger].keyOn();
            } else {
                e[noteEvent.finger].keyOff();
            }
        }
    }
}